import sys
import logging.config
from box.argparse import Program
from .command import Command
from .settings import settings

class Program(Program):
    
    #Public
     
    def __call__(self):
        self._config()
        self._execute()
         
    #Protected
    
    _command_class = Command
    
    def _config(self):
        logging.config.dictConfig(settings.logging)        
        logger = logging.getLogger()
        if self._command.debug:
            logger.setLevel(logging.DEBUG)
        if self._command.verbose:
            logger.setLevel(logging.INFO)
        if self._command.quiet:
            logger.setLevel(logging.ERROR)      
    
    def _execute(self):
        print(self._command.path)
    
        
program = Program(sys.argv)