import os
import inspect
import unittest
from abc import ABCMeta, abstractmethod
from box.findtools import find_objects

class SetupTest(unittest.TestCase, metaclass=ABCMeta):

    #Public
    
    __test__ = False
    
    def setUp(self):
        self.setup_package = find_objects(
            objname='package', 
            filepath='setup.py', 
            basedir=self._basedir, 
            getfirst=True)

    def test_version(self):
        self.assertEqual(
            self.setup_package['version'], 
            self._package.version)
        
    #Protected
    
    @property
    def _basedir(self):
        package_dirname = os.path.dirname(inspect.getfile(self._package))
        return os.path.join(package_dirname, '..')
    
    @property
    @abstractmethod
    def _package(self):
        pass #pragma: no cover